#include "Visu.h"

#include <ArmarXCore/core/logging/Logging.h>

#include <RobotAPI/libraries/ArmarXObjects/ObjectID.h>

namespace armarx::priorknowledge::util::common_place
{
    viz::Layer
    Visu::commonPlaceToLayer(const std::string& layerName,
                             const std::map<std::string, CommonPlaceData>& commonPlaceData) const
    {
        auto layer = arviz.layer(layerName);
        for (auto& [id, data] : commonPlaceData)
        {
            auto o = armarx::viz::Object("");
            o = o.fileByObjectFinder(armarx::ObjectID(data.objectId));
            o.pose(data.globalPose).alpha(0.5);
            layer.add(o);
        }
        return layer;
    }

} // namespace armarx::priorknowledge::util::common_place
