#pragma once

// Base Class
#include "../Converter.h"

// ArmarX
#include "../json/JsonConverter.h"

namespace armarx::armem::server::ltm::processor::converter::data::object
{
    class BsonConverter;
    using BsonConverterPtr = std::shared_ptr<BsonConverter>;

    class BsonConverter : public ObjectConverter
    {
    public:
        BsonConverter() : ObjectConverter(ConverterType::Binary, "dict", ".bson")
        {
        }

    protected:
        ConversionResult _convert(const aron::data::DictPtr& data) final;
        aron::data::DictPtr _convert(const ConversionResult& data,
                                     const armarx::aron::Path& p) final;

    private:
        JsonConverter jsonConverter;
    };
} // namespace armarx::armem::server::ltm::processor::converter::data::object
