#pragma once

// STD/STL
#include <memory>

// Simox
#include <SimoxUtility/json.h>

// ArmarX
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>

#include "../../extractor/Extractor.h"

namespace armarx::armem::server::ltm::processor
{
    class TypeConverter
    {
    public:
        TypeConverter(const std::string& id, const std::string& s) : identifier(id), suffix(s)
        {
        }

        virtual ~TypeConverter() = default;

        virtual std::pair<std::vector<unsigned char>, std::string>
        convert(const aron::type::ObjectPtr& data) = 0;
        virtual aron::type::ObjectPtr convert(const std::vector<unsigned char>& data,
                                              const std::string&) = 0;
        virtual void configure(const nlohmann::json& json);

    public:
        const std::string identifier;
        const std::string suffix;
    };
} // namespace armarx::armem::server::ltm::processor
