#include "ProviderInfo.h"

namespace armarx
{
    namespace skills
    {
        skills::manager::dto::ProviderInfo
        ProviderInfo::toIce() const
        {
            skills::manager::dto::ProviderInfo ret;
            ret.providerId = providerId.toManagerIce();
            ret.providerInterface = providerInterface;

            for (const auto& [k, v] : providedSkills)
            {
                ret.providedSkills[k.toManagerIce()] = v.toManagerIce();
            }
            return ret;
        }

        ProviderInfo
        ProviderInfo::FromIce(const manager::dto::ProviderInfo& i)
        {
            std::map<SkillID, SkillDescription> m;
            for (const auto& [k, v] : i.providedSkills)
            {
                m.insert({skills::SkillID::FromIce(k), skills::SkillDescription::FromIce(v)});
            }
            return ProviderInfo{skills::ProviderID::FromIce(i.providerId), i.providerInterface, m};
        }
    } // namespace skills
} // namespace armarx
