#include "SkillExecutionID.h"

namespace armarx
{
    namespace skills
    {
        skills::manager::dto::SkillExecutionID
        SkillExecutionID::toManagerIce() const
        {
            skills::manager::dto::SkillExecutionID ret;
            ret.skillId = skillId.toManagerIce();
            ret.executorName = executorName;
            armarx::core::time::toIce(ret.executionStartedTime, executionStartedTime);
            return ret;
        }

        skills::provider::dto::SkillExecutionID
        SkillExecutionID::toProviderIce() const
        {
            skills::provider::dto::SkillExecutionID ret;
            ret.skillId = skillId.toProviderIce();
            ret.executorName = executorName;
            armarx::core::time::toIce(ret.executionStartedTime, executionStartedTime);
            return ret;
        }

        SkillExecutionID
        SkillExecutionID::FromIce(const skills::manager::dto::SkillExecutionID& i)
        {
            armarx::core::time::DateTime t;
            armarx::core::time::fromIce(i.executionStartedTime, t);
            return {skills::SkillID::FromIce(i.skillId), i.executorName, t};
        }

        SkillExecutionID
        SkillExecutionID::FromIce(const skills::provider::dto::SkillExecutionID& i,
                                  const std::optional<skills::ProviderID>& providerName)
        {
            armarx::core::time::DateTime t;
            armarx::core::time::fromIce(i.executionStartedTime, t);
            return {skills::SkillID::FromIce(i.skillId, providerName), i.executorName, t};
        }
    } // namespace skills
} // namespace armarx
