#include "SimpleSkill.h"

namespace armarx::skills
{
    Skill::InitResult
    SimpleSkill::init()
    {
        InitInput i;
        i.executorName = this->executorName;
        i.parameters = this->parameters;
        return this->init(i);
    }

    Skill::MainResult
    SimpleSkill::main()
    {
        MainInput i;
        i.executorName = this->executorName;
        i.parameters = this->parameters;
        i.callback = this->callback;
        return this->main(i);
    }

    Skill::ExitResult
    SimpleSkill::exit()
    {
        ExitInput i;
        i.executorName = this->executorName;
        i.parameters = this->parameters;
        return this->exit(i);
    }

    Skill::InitResult
    SimpleSkill::init(const InitInput& in)
    {
        // Default nothing to init
        return {.status = TerminatedSkillStatus::Succeeded};
    }

    Skill::MainResult
    SimpleSkill::main(const MainInput& in)
    {
        // This is just a dummy implementation
        ARMARX_IMPORTANT << "Dummy executing skill '" << description.skillId
                         << "'. Please overwrite this method.";
        return {.status = TerminatedSkillStatus::Succeeded, .data = nullptr};
    }

    Skill::ExitResult
    SimpleSkill::exit(const ExitInput& in)
    {
        // Default nothing to exit
        return {.status = TerminatedSkillStatus::Succeeded};
    }
} // namespace armarx::skills
