#pragma once

#include <RobotAPI/libraries/aron/core/type/variant/container/Object.h>
#include <RobotAPI/libraries/skills/core/Skill.h>

// Debug
#include <RobotAPI/libraries/aron/converter/json/NLohmannJSONConverter.h>

namespace armarx
{
    namespace skills
    {
        template <class AronT>
        class SpecializedSkill : public Skill
        {
        public:
            using Base = Skill;
            using ParamType = AronT;

            using Skill::Skill;
            virtual ~SpecializedSkill() = default;

            void
            setParameters(const AronT& d)
            {
                std::scoped_lock l(this->parametersMutex);
                this->parameters = d;

                Base::setParameters(d.toAron());
            }

            AronT
            getParameters() const
            {
                std::scoped_lock l(this->parametersMutex);
                return this->parameters;
            }

            /// returns the accepted type of the skill
            static armarx::aron::type::ObjectPtr
            GetAcceptedType()
            {
                return AronT::ToAronType();
            }


        protected:
            mutable std::mutex parametersMutex;
            AronT parameters;
        };
    } // namespace skills
} // namespace armarx
